| Version: 3.3.1

Public Member Functions | List of all members
wxDPIChangedEvent Class Reference
Class List by Category » Events

`#include <wx/event.h>`

Inheritance diagram for wxDPIChangedEvent:
[legend]

## Detailed Description

Event sent when the display scale factor or pixel density (measured in dots-per-inch, or DPI) of the monitor a window is on changes.

The event is sent to each wxTopLevelWindow affected by the change, and all its children recursively (post-order traversal). For example, this event is sent to the window when it is moved, by the user, from a display using some DPI value to another display using a different DPI value. It also sent to all program windows on the given display if its DPI changes due to a change in the system settings.

If you define an event handler for this event, you should almost always call `event.Skip()` in it in order to allow the base class handler to execute, as many controls rely on processing this event in order to update their appearance when the DPI changes. However the default handler for the top level window itself only sets the new window size, by scaling the current size by the DPI ratio – e.g. doubling it if the DPI has changed from normal to "high", i.e. 200%, one – and also ensuring that the window is still bigger than its best size, as returned by wxWindow::GetBestSize(). Note that in some cases this may cause the window size to grow unexpectedly and you may prefer to call wxWindow::SetSize() in your handler of this event for the top level window and not call `event.Skip()` to prevent the default handler from resizing the window.

Currently this event is generated by wxMSW port if only and only if the MSW application runs under Windows 10 Creators Update (v1703) or later and is marked as being "per-monitor DPI aware", i.e. contains a `dpiAwareness` tag with the value "PerMonitorV2" in its manifest (see Microsoft "Application Manifests" documentation for more details).

This event is generated by wxGTK when using GTK 3.10 or later and only since wxWidgets version 3.3.0.

## Events using this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxDPIChangedEvent& event)

Event macros:

- EVT_DPI_CHANGED(func):
  Process a `wxEVT_DPI_CHANGED` event.

Since
  3.1.3

##

Library: wxCore
Category: Events

See also
  Events and Event Handling

## Public Member Functions
wxSize | GetOldDPI () const
| Returns the old DPI. More...
wxSize | GetNewDPI () const
| Returns the new DPI. More...
wxSize | Scale (wxSize sz) const
| Rescale a value in pixels to match the new DPI. More...
wxPoint | Scale (wxPoint pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
wxRect | Scale (wxRect rect) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
int | ScaleX (int x) const
| Rescale horizontal component to match the new DPI. More...
int | ScaleY (int y) const
| Rescale vertical component to match the new DPI. More...
Public Member Functions inherited from wxEvent
| wxEvent (int id=0, wxEventType eventType=wxEVT_NULL)
| Constructor. More...
virtual wxEvent * | Clone () const =0
| Returns a copy of the event. More...
wxObject * | GetEventObject () const
| Returns the object (usually a window) associated with the event, if any. More...
wxEventType | GetEventType () const
| Returns the identifier of the given event type, such as `wxEVT_BUTTON`. More...
virtual wxEventCategory | GetEventCategory () const
| Returns a generic category for this event. More...
int | GetId () const
| Returns the identifier associated with this event, such as a button command id. More...
wxObject * | GetEventUserData () const
| Return the user data associated with a dynamically connected event handler. More...
bool | GetSkipped () const
| Returns true if the event handler should be skipped, false otherwise. More...
long | GetTimestamp () const
| Gets the timestamp for the event. More...
bool | IsCommandEvent () const
| Returns true if the event is or is derived from wxCommandEvent else it returns false. More...
void | ResumePropagation (int propagationLevel)
| Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation). More...
void | SetEventObject (wxObject *object)
| Sets the originating object. More...
void | SetEventType (wxEventType type)
| Sets the event type. More...
void | SetId (int id)
| Sets the identifier associated with this event, such as a button command id. More...
void | SetTimestamp (long timeStamp=0)
| Sets the timestamp for the event. More...
bool | ShouldPropagate () const
| Test if this event should be propagated or not, i.e. if the propagation level is currently greater than 0. More...
void | Skip (bool skip=true)
| This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns. More...
int | StopPropagation ()
| Stop the event from propagating to its parent window. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to nullptr the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=nullptr, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxEvent
int | m_propagationLevel
| Indicates how many levels the event can propagate. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Member Function Documentation

## ◆ GetNewDPI()

wxSize wxDPIChangedEvent::GetNewDPI | ( |  | ) | const

Returns the new DPI.

## ◆ GetOldDPI()

wxSize wxDPIChangedEvent::GetOldDPI | ( |  | ) | const

Returns the old DPI.

## ◆ Scale() [1/3]

wxPoint wxDPIChangedEvent::Scale | ( | wxPoint | pt | ) | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ Scale() [2/3]

wxRect wxDPIChangedEvent::Scale | ( | wxRect | rect | ) | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ Scale() [3/3]

wxSize wxDPIChangedEvent::Scale | ( | wxSize | sz | ) | const

Rescale a value in pixels to match the new DPI.

This is a convenience function to use in wxEVT_DPI_CHANGED event handlers, as they often need to update some sizes to the new DPI. It simply calls wxMulDivInt32() with new and old DPI values, but is more readable and less error-prone.

For example, the returned value will be twice bigger than the original one when switching from normal (96) DPI to high (2x, 192) DPI.

The overloads taking wxPoint and wxRect are only available in wxWidgets 3.3.0 and later.

Since
  3.1.6

## ◆ ScaleX()

int wxDPIChangedEvent::ScaleX | ( | int | x | ) | const

Rescale horizontal component to match the new DPI.

This is the same as Scale(), but for the horizontal component only.

Since
  3.1.6

## ◆ ScaleY()

int wxDPIChangedEvent::ScaleY | ( | int | y | ) | const

Rescale vertical component to match the new DPI.

This is the same as Scale(), but for the vertical component only.

Since
  3.1.6